; TesTElec v1.02 (c)2000 par Denis SANCHEZ
; version TI-83

;les deux bits d'entre/sortie sont : ab
;a = Up/Reset (si a=0 : Reset)
;b = Clk

.NOLIST
#define end .end
#define END .end
#define equ .equ
#define EQU .equ
#include "ti83asm.inc"
.LIST

;---------- Zone des constantes ----------

C_00			= $D3						;code correspondant au %00
C_01			= $D2						;code correspondant au %01
C_10			= $D1						;code correspondant au %10
C_11			= $D0						;code correspondant au %11

K_RIGHT		= $1A
K_LEFT		= $18
K_UP			= $19
K_DOWN		= $22
K_YEDIT		= $0B
K_WINDOW		= $0C
K_TRACE		= $0E
K_GRAPH		= $0F
C_N_OCTETS	= 64						;nombre d'octets  lire sur la carte (512)
C_LIGNE_MAX	= 57						;C_N_OCTETS-7 valeur  laquelle on arrte le dfilement bas

;---------- Zone d'initialisation ----------

.org $9327

	ld A,0
	ld (LECTURE_OK),A					;il n'y a pas encore eu de lecture => pas d'affichage
	ld A,C_11
	out (BPORT),A						;les 2 bits du cble  +5V

;---------- Zone du programme ----------

	call _clrScrnFull					;ecran effac
	call _runIndicOff					;pas de d'indicateur en haut  gauche
	call affiche_menu					;affiche le menu en bas (text font)

test_key:
	call	_getK
	call	_OP2TOOP1
	call	_CONVOP1
	cp K_TRACE
	jr z,auteur
	cp K_UP
	jr z,up
	cp K_DOWN
	jr z,down
	cp K_LEFT
	jr z,left
	cp K_RIGHT
	jr z,right
	cp K_YEDIT
	jp z,lecture
	cp K_WINDOW
	jp z,change_mode
	cp K_GRAPH
	jr nz,test_key
quitter:
	call _clrScrnFull					;efface l'cran
	ret

up:
	ld A,(LIGNE_POS)
	cp 0
	jr z,test_key						;si on est tout en haut (ligne 0) on dcrmente pas
	dec A
	ld (LIGNE_POS),A
	jp affiche							;actualisation des lignes data (si on est en mode DATA)

down:
	ld A,(LIGNE_POS)
	cp C_LIGNE_MAX
	jr z,test_key						;si on est  la dernire ligne, on incrmente pas
	inc A
	ld (LIGNE_POS),A
	jp affiche							;actualisation des lignes data (si on est en mode DATA)

left:
	ld A,(LIGNE_POS)
	cp 7
	jr c,left2							;si le n de ligne est >=7 on peut soustraire 7
	sub 7
	ld (LIGNE_POS),A
	jp affiche							;actualisation des lignes data (si on est en mode DATA)
left2:
	ld A,0								;sinon on va  la ligne du dbut
	ld (LIGNE_POS),A
	jp affiche							;actualisation des lignes data (si on est en mode DATA)

right:
	ld A,(LIGNE_POS)
	add A,7
	cp C_LIGNE_MAX
	jr nc,right2						;si le n de ligne ne dpasse pas la limite : C_LIGNE_MAX
	ld (LIGNE_POS),A
	jr affiche							;actualisation des lignes data (si on est en mode DATA)
right2:
	ld A,C_LIGNE_MAX					;sinon on va  la dernire ligne
	ld (LIGNE_POS),A
	jr affiche							;actualisation des lignes data (si on est en mode DATA)

auteur:
	call _clrScrnFull					;on efface l'cran
	call affiche_menu
	ld HL,$0101
	ld (currow), HL
	ld HL,auteur_txt1
	call _puts
	ld HL,$0403
	ld (currow), HL
	ld HL,auteur_txt2
	call _puts
	ld HL,$0104
	ld (currow), HL
	ld HL,auteur_txt3
	call _puts
auteur2:
	call	_getkey
	cp 0
	jr z,auteur2
	jr affiche0

change_mode:
	ld A,(MODE_MENU)					;mode actuel
	xor $FF								;slecstion de l'autre mode : A<-A/
	ld (MODE_MENU),A					;nouveau mode
affiche0:
	call _clrScrnFull
	call affiche_menu					;affichage du menu
affiche:
	ld A,(LECTURE_OK)
	cp 0
	jp z,test_key						;si une tlcarte n'a pas encore t lu, pas la peine de continuer
	ld A,(MODE_MENU)					;saisie du mode
	cp 0
	jr z,change_mode2
	call affiche_data					;les donnes
	jp test_key
change_mode2:
	call affiche_info					;les infos
	jp test_key

lecture:
	ld A,255
	ld (LECTURE_OK),A					;c'est bon, une tlcarte a t lue
	ld A,0
	ld (LIGNE_POS),A					;on affichera les donnes en commencant par la 1er lignes
	ld A,C_00							;prparation du #Reset#
	out (BPORT),A						;%00 sur le "Link"
	call pause							;une petite tempo (evitez les erreures dues au condo)
	ld A,C_01							;front montant de Clk => #Reset#
	out (BPORT),A
	call pause
	ld A,C_10							;il faut +5V en sortie pour pouvoir lire le bit prsent sur le port. sinon toujours  zro.
	out (BPORT),A
	ld HL,DATA_MEM						;adresse o commence la zone data
	ld (DATA_POS),HL					;sauvegarde dans DATA_POS (compteur)
	in A,(BPORT)						;saisie des bits prsents sur le "LINK"
	and %00000010						;on isole le bit 1 (bit de donne)
	rrca
	rrca									;on place le bit de donne  sur le bit 7 de A
	ld (HL),A							;sauvegarde dans la zone data (toujours pointe par HL)
	call pause
	ld A,0
	ld (N_OCTETS),A					;initialisation du compteur d'octets
	ld A,%01000000						;le bit 7  dj t sauv
	ld (N_BITS),A						;initialisation du compteur de bit (masque)
	jr lecture3							;compteurs dj initialiss
lecture2:
		ld (HL),0						;on efface l'octet pour pouvoir y crire grce au masque.
											;HL=(DATA_POS) si jr lecture2
		ld A,%10000000
		ld (N_BITS),A					;initialisation du compteur de bits
lecture3:
			ld A,C_11					;front montant de Clk => #Up#
			out (BPORT),A
			call pause
			ld A,C_10					;front descendant de Clk
			out (BPORT),A
			in A,(BPORT)				;saisie des bits prsents sur le "LINK"
			bit 1,A						;on isole le bit donne de la tlcarte
			jr z,lecture4				;si il est  zro on ne touche pas  la zone data (bit dj  zro)
			ld A,(N_BITS)				;on place le masque/compteur de bits dans B
			ld HL,(DATA_POS)			;adresse point dans la zone data
			or (HL)						;le bit est mis  "1" : A<-A or HL
			ld (HL),A					;puis il est sock en mmoire
lecture4:
			call pause
			ld A,(N_BITS)
			rrca							;bit suivant
			ld (N_BITS),A
			jr nc,lecture3				;si c'tait le dernier bit, pas de saut
		ld HL,(DATA_POS)
		inc HL							;incrmentation du pointeur de la zone data
		ld (DATA_POS),HL
		ld A,(N_OCTETS)
		inc A								;incrmentation compteur d'octet
		ld (N_OCTETS),A
		cp C_N_OCTETS
		jr nz,lecture2					;si c'tait le dernier octets pas de saut
	ld A,C_11
	out (BPORT),A						;les 2 bits du cble  +5V
	jp affiche

;---------- Zone des sous-programmes ----------

_mul_hl_10:								;on ne trouve la pas sur TI-83 (contrairement  la TI86)
	ld B,H
	ld C,L
	sla C									;BC=BC*2
	rl B
	sla H									;HL=HL*8
	rl L
	sla H
	rl L
	sla H
	rl L
	add HL,BC
	ret

pause:
	ld HL,50
pause2:
	dec HL
	ld A,H
	or L
	cp 0
	jr nz,pause2						;si HL=0 fini la pause
	ret

affiche_info_call:
	ld A,%10000000
	ld (N_BITS),A						;initialisation du masque/compteur de bits
affiche_info_call2:
		and D								;dans D il y a l'octet qui correspond au compteur (de poid BC)
		jr z,affiche_info_call3		;si le bit est  1 on pourra soustraire BC
		ld HL,(UNITES)
		sbc HL,BC						;HL<-HL-BC
		ld (UNITES),HL
affiche_info_call3:
		ld A,(N_BITS)
		rrca								;bit suivant
		ld (N_BITS),A
		jr nc,affiche_info_call2
	ret


affiche_hex:
	ld (N_OCTETS),A					;dans nombre d'octets  afficher en hexa
affiche_hex1:
		ld A,(HL)						;HL pointe la zone data  afficher
		rrca
		rrca
		rrca
		rrca
		and $0F							;on isole le quartet de poid fort
		cp 10
		jr c,affiche_hex2				;si c'est une lettre (A...F) pas de saut
		add A,7
affiche_hex2:
		add A,'0'						;conversion du quartet en ASCII
		call _putc						;affichage (avec actualisation du curseur compris)
		ld A,(HL)
		and $0F							;on isole le quartet de poid faible
		cp 10
		jr c,affiche_hex3
		add A,7
affiche_hex3:
		add A,'0'
		call _putc
		inc HL
		ld A,(N_OCTETS)
		dec A								;dcrmentation du compteur d'octet
		ld (N_OCTETS),A
		cp 0
		jr nz,affiche_hex1			;test si tous les octets ont t affichs
	ret

affiche_info:
	; ########## Type ##########
	ld HL,0
	ld (currow),HL
	ld HL,info_txt1
	call _puts
	ld A,(CODE_FAMILLE)
	ld HL,info_txt7
	dec A
	cp 7
	jr c,affiche_info2
	ld HL,info_txt8
	cp $3F								;$40-1 ( cause du 'dec A')
	jr z,affiche_info2
	ld HL,info_txt9
affiche_info2:
	call _puts
	; ########## Code famille ##########
	ld HL,1
	ld (currow),HL
	ld HL,info_txt2
	call _puts
	ld HL,CODE_FAMILLE
	ld A,1
	call affiche_hex
	ld A,(CODE_FAMILLE)
	cp 0
	ret z
	cp 8
	jr c,affiche_info5
	cp $40
	ret nz
affiche_info5:
	; ########## N srie ##########
	ld HL,2
	ld (currow),HL
	ld HL,info_txt3
	call _puts
	ld HL,NUM_SERIE
	ld A,(CODE_FAMILLE)
	cp $40
	jr z,affiche_info6
	; ########## N srie (T1G) ##########
	ld A,2
	call affiche_hex
	inc HL
	ld A,2
	call affiche_hex
	jr affiche_info8
	; ########## N srie (T2G) ##########
affiche_info6:
	ld A,4
	call affiche_hex
	ld A,(HL)
	rrca
	rrca
	rrca
	rrca
	and $0F
	cp 10
	jr c,affiche_info7
	add A,7
affiche_info7:
	add A,'0'
	call _putc
affiche_info8:
	; ########## Capacit ##########
	ld HL,$0503
	ld (currow),HL
	ld A,(CODE_FAMILLE)
	cp $40								;si c'est une T2G
	jr z,affiche_info10
	; ########## Capacit (T1G) ##########
	ld A,(CAPACITE_T1G)
	rrca
	rrca
	rrca
	rrca
	and $0F
	ld H,0
	ld L,A
	call _mul_hl_10					;HL=HL*10
	ld A,(CAPACITE_T1G)
	and $0F
	ld B,0
	ld C,A
	add HL,BC
	call _mul_hl_10					;HL=HL*10
	ld (UNITES),HL
	ld B,0
	ld C,10
	sbc HL,BC
	call _dispHL
	jr affiche_info11
	; ########## Capacit (T2G) ##########
affiche_info10:
	ld A,(CAPACITE_T2G)
	and %01111111						;on efface le bit qui ne fait pas partie de la capacit.
	ld H,0
	ld L,A
	call _mul_hl_10					;HL=HL*10
	ld (UNITES),HL
	call _dispHL
	; ########## Capacit (suite) ##########
affiche_info11:
	ld HL,info_txt4b
	call _puts
	ld HL,3
	ld (currow), HL
	ld HL,info_txt4
	call _puts
	; ########## Crdit ##########
	ld HL,$0504
	ld (currow), HL
	ld A,(CODE_FAMILLE)
	cp $40								;si c'est une T2G
	jr z,affiche_info15
	; ########## Crdit (T1G) ##########
	ld A,19
	ld (N_OCTETS),A
	ld HL,UNITES_T1G
	ld (DATA_POS),HL
affiche_info12:
		ld A,%10000000
		ld (N_BITS),A
affiche_info13:
			ld HL,(DATA_POS)
			and (HL)
			jr z,affiche_info14
			ld HL,(UNITES)
			dec HL
			ld (UNITES),HL
affiche_info14:
			ld A,(N_BITS)
			rrca
			ld (N_BITS),A
			jr nc,affiche_info13
		ld HL,(DATA_POS)
		inc HL
		ld (DATA_POS),HL
		ld A,(N_OCTETS)
		dec A
		ld (N_OCTETS),A
		cp 0
		jr nz,affiche_info12
	jr affiche_info16
	; ########## Crdit (T2G) ##########
affiche_info15:
	ld A,(COMPTEUR_512)
	ld D,A
	ld BC,512
	call affiche_info_call
	ld A,(COMPTEUR_64)
	ld D,A
	ld BC,64
	call affiche_info_call
	ld A,(COMPTEUR_8)
	and %11111110
	ld D,A
	ld BC,8
	call affiche_info_call
	ld A,(COMPTEUR_1)
	and %11111110
	ld D,A
	ld BC,1
	call affiche_info_call			;on trouve maintenant le crdit restant dans UNITES
	; ########## Crdit (suite) ##########
affiche_info16:
	ld HL,$0504							;ligne 4, colonne 8
	ld (currow), HL					;position du curseur
	ld HL,(UNITES)
	call _dispHL						;affichage de AHL en dcimal
	ld HL,info_txt4b
	call _puts
	ld HL,4
	ld (currow), HL
	ld HL,info_txt5
	call _puts
	ld A,(CODE_FAMILLE)
	cp $40
	ret z									;si c'est une T2G on arrte l
	; ########## Paramtre ##########
	ld HL,5
	ld (currow),HL
	ld HL,info_txt6
	call _puts
	ld HL,info_txt10
	ld A,(PARAMETRE)
	rrca
	rrca
	rrca
	rrca
	and $0F
	cp 1
	jr z,affiche_info17
	ld HL,info_txt11
	cp 0
	jr z,affiche_info17
	ld HL,info_txt12
affiche_info17:
	call _puts
	ret

affiche_data:
	ld A,(LIGNE_POS)					;ligne o dbut l'affichage
	ld (LIGNE_POS2),A					;sauvegarde dans le compteur de ligne (position)
	ld D,0
	ld E,A
	ld HL,DATA_MEM
	add HL,DE
	ld (DATA_POS),HL					;sauvegarde de la position dans le compteur data
	ld A,0
	ld (N_LIGNES),A					;initialisation du compteur de ligne (0  7)
affiche_data2:
		ld H,0
		ld A,(N_LIGNES)
		ld L,A
		ld (currow),HL					;ligne=position de ligne , colonne=0
		ld A,(LIGNE_POS2)				;affichage de l'adresse
		rlca
		rlca
		rlca
		and %00000111
		add A,'0'
		call _putc
		ld A,(LIGNE_POS2)
		rrca
		and $0F
		cp 10
		jr c,affiche_data3
		add A,7
affiche_data3:
		add A,'0'
		call _putc						;1er chiffre de l'adresse
		ld A,(LIGNE_POS2)
		bit 0,A
		ld A,'0'
		jr z,affiche_data4
		ld A,'8'
affiche_data4:
		call _putc						;2eme chiffre de l'adresse
		ld A,':'
		call _putc						;3eme chiffre de l'adresse (toujours  zro)
		ld A,' '
		call _putc
		ld A,%10000000
		ld (N_BITS),A				;initialisation du "compteur"
affiche_data6:
			ld HL,(DATA_POS)
			ld A,(N_BITS)
			and (HL)
			ld A,'0'
			jr z,affiche_data7
			inc A
affiche_data7:
			call _putc
			ld A,(N_BITS)
			rrca
			ld (N_BITS),A
			jr nc,affiche_data6
		ld HL,(DATA_POS)
		inc HL
		ld (DATA_POS),HL
		ld A,(LIGNE_POS2)
		inc A
		ld (LIGNE_POS2),A
		ld A,(N_LIGNES)
		inc A
		ld (N_LIGNES),A
		cp 7
		jp nz,affiche_data2
	ret

affiche_menu:
	ld HL,$3A00
	ld (pencol), HL
	ld HL,text_menu1
	ld A,(MODE_MENU)
	cp 0
	jr z,affiche_menu2
	ld HL,text_menu2
affiche_menu2:
	call _vputs
	ret

;---------- Zone des donnes ----------

info_txt1:
	.db "Type  :",0
info_txt2:
	.db "Code f:",0
info_txt3:
	.db "S/N   :",0
info_txt4:
	.db "Capa. :",0
info_txt4b:
	.db " utc",0
info_txt5:
	.db "Cr",150,"dit:",0
info_txt6:
	.db "Vpp   :",0
info_txt7:
	.db "T1G",0
info_txt8:
	.db "T2G",0
info_txt9:
	.db "inconnu",0
info_txt10:
	.db "21 V",0
info_txt11:
	.db "25 V",0
info_txt12:
	.db "?",0
auteur_txt1:
	.db "TesTElec v1.02",0
auteur_txt2:
	.db "(c)2000",0
auteur_txt3:
	.db "Denis SANCHEZ",0
text_menu1:
	.db "Lect.|"
	.db "Info|"
	.db "                |"
	.db "Auteur|"
	.db "Quit.",0
text_menu2:
	.db "Lect.|"
	.db "Data|"
	.db "                |"
	.db "Auteur|"
	.db "Quit.",0
MODE_MENU:
	.db $FF
LECTURE_OK:								;si <> 0 il y a dj eut une lecture
	.db 0
N_BITS:									;utilis pour les compteurs de bits
	.db 0
N_OCTETS:								;utilis pour les compteurs d'octets
	.db 0
DATA_POS:								;adresse de la RAM o en est la lecture/criture
	.db 0,0
PORT_OUT:								;tampon du "LINK"
	.db 0
LIGNE_POS:								;numro de la 1er ligne qui est affich (0  C_LIGNE_MAX)
	.db 0
LIGNE_POS2:								;numro de la ligne qui est traite (0  C_LIGNE_MAX+6)
	.db 0
N_LIGNES:								;numro de la ligne cran qui est traite (0  7)
	.db 0
UNITES:
	.db 0,0

DATA_MEM:								;zone donnes (512 bits)
	.db 0
CODE_FAMILLE:
	.db 0
NUM_SERIE:
	.db 0,0,0,0,0
CAPACITE_T2G:
	.db 0
COMPTEUR_512:
	.db 0
COMPTEUR_64:
	.db 0
PARAMETRE:
COMPTEUR_8:
	.db 0
CAPACITE_T1G:
COMPTEUR_1:
	.db 0
UNITES_T1G:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0

.end
